// BoxerCtl.cpp :   ActiveX CBoxerCtrl.

#include "stdafx.h"
#include "boxer.h"
#include "BoxerCtl.h"
#include "BoxerPpg.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


IMPLEMENT_DYNCREATE(CBoxerCtrl, COleControl)


/////////////////////////////////////////////////////////////////////////////
//  

BEGIN_MESSAGE_MAP(CBoxerCtrl, COleControl)
    //{{AFX_MSG_MAP(CBoxerCtrl)
    ON_WM_LBUTTONDOWN()
    //}}AFX_MSG_MAP
    ON_OLEVERB(AFX_IDS_VERB_PROPERTIES, OnProperties)
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////
//  

BEGIN_DISPATCH_MAP(CBoxerCtrl, COleControl)
    //{{AFX_DISPATCH_MAP(CBoxerCtrl)
        //  -  ClassWizard     .
        //       !
    //}}AFX_DISPATCH_MAP
    DISP_FUNCTION_ID(CBoxerCtrl, "AboutBox", DISPID_ABOUTBOX, AboutBox, VT_EMPTY, VTS_NONE)
END_DISPATCH_MAP()


/////////////////////////////////////////////////////////////////////////////
//  

BEGIN_EVENT_MAP(CBoxerCtrl, COleControl)
    //{{AFX_EVENT_MAP(CBoxerCtrl)
        //  -  ClassWizard     .
        //       !
    //}}AFX_EVENT_MAP
END_EVENT_MAP()


/////////////////////////////////////////////////////////////////////////////
//  

// TODO:      . 
//     !
BEGIN_PROPPAGEIDS(CBoxerCtrl, 1)
    PROPPAGEID(CBoxerPropPage::guid)
END_PROPPAGEIDS(CBoxerCtrl)


/////////////////////////////////////////////////////////////////////////////
//     guid

IMPLEMENT_OLECREATE_EX(CBoxerCtrl, "BOXER.BoxerCtrl.1",
    0xb2c1e6, 0x95a2, 0x11d0, 0x88, 0x60, 0x44, 0x45, 0x53, 0x54, 0, 0)


/////////////////////////////////////////////////////////////////////////////
//     

IMPLEMENT_OLETYPELIB(CBoxerCtrl, _tlid, _wVerMajor, _wVerMinor)


/////////////////////////////////////////////////////////////////////////////
//  

const IID BASED_CODE IID_DBoxer =
        { 0xb2c1e4, 0x95a2, 0x11d0, { 0x88, 0x60, 0x44, 0x45, 
          0x53, 0x54, 0, 0 } };
const IID BASED_CODE IID_DBoxerEvents =
        { 0xb2c1e5, 0x95a2, 0x11d0, { 0x88, 0x60, 0x44, 0x45, 
          0x53, 0x54, 0, 0 } };


/////////////////////////////////////////////////////////////////////////////
//    

static const DWORD BASED_CODE _dwBoxerOleMisc =
    OLEMISC_ACTIVATEWHENVISIBLE |
    OLEMISC_SETCLIENTSITEFIRST |
    OLEMISC_INSIDEOUT |
    OLEMISC_CANTLINKINSIDE |
    OLEMISC_RECOMPOSEONRESIZE;

IMPLEMENT_OLECTLTYPE(CBoxerCtrl, IDS_BOXER, _dwBoxerOleMisc)


/////////////////////////////////////////////////////////////////////////////
// CBoxerCtrl::CBoxerCtrlFactory::UpdateRegistry -
//        CBoxerCtrl

BOOL CBoxerCtrl::CBoxerCtrlFactory::UpdateRegistry(BOOL bRegister)
{
    // ,     
    //   .   
    //   MFC TechNote 64.
    //      ,
    //     
    //   6-   afxRegApartmentThreading  0.

    if (bRegister)
        return AfxOleRegisterControlClass(
            AfxGetInstanceHandle(),
            m_clsid,
            m_lpszProgID,
            IDS_BOXER,
            IDB_BOXER,
            afxRegApartmentThreading,
            _dwBoxerOleMisc,
            _tlid,
            _wVerMajor,
            _wVerMinor);
    else
        return AfxOleUnregisterClass(m_clsid, m_lpszProgID);
}


/////////////////////////////////////////////////////////////////////////////
// CBoxerCtrl::CBoxerCtrl - 

CBoxerCtrl::CBoxerCtrl()
{
    InitializeIIDs(&IID_DBoxer, &IID_DBoxerEvents);

    // TODO:     .
    fill1 = fill2 = fill3 = fill4 = false;
}


/////////////////////////////////////////////////////////////////////////////
// CBoxerCtrl::~CBoxerCtrl - 

CBoxerCtrl::~CBoxerCtrl()
{
    // TODO:     .
}


/////////////////////////////////////////////////////////////////////////////
// CBoxerCtrl::OnDraw -  

void CBoxerCtrl::OnDraw(
            CDC* pdc, const CRect& rcBounds, const CRect& rcInvalid)
{
    // TODO:      .
    pdc->FillRect(rcBounds,
       CBrush::FromHandle((HBRUSH)GetStockObject(WHITE_BRUSH)));

    box1 = CRect(rcBounds.left, rcBounds.top, 
                 rcBounds.right/2, rcBounds.bottom/2);
    box2 = CRect(rcBounds.left, rcBounds.bottom/2, 
                 rcBounds.right/2, rcBounds.bottom);
    box3 = CRect(rcBounds.right/2, rcBounds.top, 
                 rcBounds.right, rcBounds.bottom/2);
    box4 = CRect(rcBounds.right/2, rcBounds.bottom/2, 
                 rcBounds.right, rcBounds.bottom);

    pdc->Rectangle(&box1);
    pdc->Rectangle(&box2);
    pdc->Rectangle(&box3);
    pdc->Rectangle(&box4);

    if(fill1) pdc->FillSolidRect(&box1, RGB(0, 0, 0));
    if(fill2) pdc->FillSolidRect(&box2, RGB(0, 0, 0));
    if(fill3) pdc->FillSolidRect(&box3, RGB(0, 0, 0));
    if(fill4) pdc->FillSolidRect(&box4, RGB(0, 0, 0));

}


/////////////////////////////////////////////////////////////////////////////
// CBoxerCtrl::DoPropExchange -  

void CBoxerCtrl::DoPropExchange(CPropExchange* pPX)
{
    ExchangeVersion(pPX, MAKELONG(_wVerMinor, _wVerMajor));
    COleControl::DoPropExchange(pPX);

    // TODO:   PX_    .

}


/////////////////////////////////////////////////////////////////////////////
// CBoxerCtrl::OnResetState -      

void CBoxerCtrl::OnResetState()
{
    COleControl::OnResetState();  //   
                                  //    DoPropExchange

    //      
}


/////////////////////////////////////////////////////////////////////////////
// CBoxerCtrl::AboutBox -    About 

void CBoxerCtrl::AboutBox()
{
    CDialog dlgAbout(IDD_ABOUTBOX_BOXER);
    dlgAbout.DoModal();
}


/////////////////////////////////////////////////////////////////////////////
//   CBoxerCtrl

void CBoxerCtrl::OnLButtonDown(UINT nFlags, CPoint point) 
{
    // TODO:     
    // /    
    fill1 = box1.PtInRect(point);
    fill2 = box2.PtInRect(point);
    fill3 = box3.PtInRect(point);
    fill4 = box4.PtInRect(point);
    Invalidate();

    COleControl::OnLButtonDown(nFlags, point);
}

