// ButtonerCtl.cpp :    ActiveX CButtonerCtrl.

#include "stdafx.h"
#include "Buttoner.h"
#include "ButtonerCtl.h"
#include "ButtonerPpg.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


IMPLEMENT_DYNCREATE(CButtonerCtrl, COleControl)


/////////////////////////////////////////////////////////////////////////////
//  

BEGIN_MESSAGE_MAP(CButtonerCtrl, COleControl)
    //{{AFX_MSG_MAP(CButtonerCtrl)
    ON_WM_LBUTTONDOWN()
    //}}AFX_MSG_MAP
    ON_MESSAGE(OCM_COMMAND, OnOcmCommand)
    ON_OLEVERB(AFX_IDS_VERB_PROPERTIES, OnProperties)
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////
//  

BEGIN_DISPATCH_MAP(CButtonerCtrl, COleControl)
    //{{AFX_DISPATCH_MAP(CButtonerCtrl)
    DISP_PROPERTY_NOTIFY(CButtonerCtrl, "data", m_data, OnDataChanged, VT_I2)
    DISP_FUNCTION(CButtonerCtrl, "Beep", Beep, VT_EMPTY, VTS_NONE)
    //}}AFX_DISPATCH_MAP
    DISP_FUNCTION_ID(CButtonerCtrl, "AboutBox", DISPID_ABOUTBOX, AboutBox, VT_EMPTY, VTS_NONE)
END_DISPATCH_MAP()


/////////////////////////////////////////////////////////////////////////////
//  

BEGIN_EVENT_MAP(CButtonerCtrl, COleControl)
    //{{AFX_EVENT_MAP(CButtonerCtrl)
    EVENT_STOCK_CLICK()
    //}}AFX_EVENT_MAP
END_EVENT_MAP()


/////////////////////////////////////////////////////////////////////////////
//  

// TODO:      . 
//     !
BEGIN_PROPPAGEIDS(CButtonerCtrl, 1)
    PROPPAGEID(CButtonerPropPage::guid)
END_PROPPAGEIDS(CButtonerCtrl)


/////////////////////////////////////////////////////////////////////////////
//     guid

IMPLEMENT_OLECREATE_EX(CButtonerCtrl, "BUTTONER.ButtonerCtrl.1",
    0x6ae5a161, 0x9584, 0x11d0, 0x88, 
    0x60, 0x44, 0x45, 0x53, 0x54, 0, 0)


/////////////////////////////////////////////////////////////////////////////
//     

IMPLEMENT_OLETYPELIB(CButtonerCtrl, _tlid, _wVerMajor, _wVerMinor)


/////////////////////////////////////////////////////////////////////////////
//  

const IID BASED_CODE IID_DButtoner =
        { 0x6ae5a15f, 0x9584, 0x11d0, { 0x88, 0x60, 0x44, 0x45, 
          0x53, 0x54, 0, 0 } };
const IID BASED_CODE IID_DButtonerEvents =
        { 0x6ae5a160, 0x9584, 0x11d0, { 0x88, 0x60, 0x44, 0x45, 
          0x53, 0x54, 0, 0 } };


/////////////////////////////////////////////////////////////////////////////
//    

static const DWORD BASED_CODE _dwButtonerOleMisc =
    OLEMISC_ACTIVATEWHENVISIBLE |
    OLEMISC_SETCLIENTSITEFIRST |
    OLEMISC_INSIDEOUT |
    OLEMISC_CANTLINKINSIDE |
    OLEMISC_RECOMPOSEONRESIZE;

IMPLEMENT_OLECTLTYPE(CButtonerCtrl, IDS_BUTTONER, _dwButtonerOleMisc)


/////////////////////////////////////////////////////////////////////////////
// CButtonerCtrl::CButtonerCtrlFactory::UpdateRegistry -
//        CBoxerCtrl

BOOL CButtonerCtrl::CButtonerCtrlFactory::UpdateRegistry(BOOL bRegister)
{
    // ,     
    //   .   
    //   MFC TechNote 64.
    //      ,
    //     
    //   6-   afxRegApartmentThreading  0.

    if (bRegister)
        return AfxOleRegisterControlClass(
            AfxGetInstanceHandle(),
            m_clsid,
            m_lpszProgID,
            IDS_BUTTONER,
            IDB_BUTTONER,
            afxRegApartmentThreading,
            _dwButtonerOleMisc,
            _tlid,
            _wVerMajor,
            _wVerMinor);
    else
        return AfxOleUnregisterClass(m_clsid, m_lpszProgID);
}


/////////////////////////////////////////////////////////////////////////////
// CButtonerCtrl::CButtonerCtrl - 

CButtonerCtrl::CButtonerCtrl()
{
    InitializeIIDs(&IID_DButtoner, &IID_DButtonerEvents);

    SetText(" !");
    // TODO:     .
    m_data = 0;
}


/////////////////////////////////////////////////////////////////////////////
// CButtonerCtrl::~CButtonerCtrl - 

CButtonerCtrl::~CButtonerCtrl()
{
    // TODO:     .
}


/////////////////////////////////////////////////////////////////////////////
// CButtonerCtrl::OnDraw -  

void CButtonerCtrl::OnDraw(
            CDC* pdc, const CRect& rcBounds, const CRect& rcInvalid)
{
    DoSuperclassPaint(pdc, rcBounds);
}


/////////////////////////////////////////////////////////////////////////////
// CButtonerCtrl::DoPropExchange -  

void CButtonerCtrl::DoPropExchange(CPropExchange* pPX)
{
    ExchangeVersion(pPX, MAKELONG(_wVerMinor, _wVerMajor));
    COleControl::DoPropExchange(pPX);

    // TODO:   PX_    .

}


/////////////////////////////////////////////////////////////////////////////
// CButtonerCtrl::OnResetState -      

void CButtonerCtrl::OnResetState()
{
    COleControl::OnResetState();  //   
                                  //    DoPropExchange

    //      
}


/////////////////////////////////////////////////////////////////////////////
// CButtonerCtrl::AboutBox -    About

void CButtonerCtrl::AboutBox()
{
    CDialog dlgAbout(IDD_ABOUTBOX_BUTTONER);
    dlgAbout.DoModal();
}


/////////////////////////////////////////////////////////////////////////////
// CButtonerCtrl::PreCreateWindow -    CreateWindowEx

BOOL CButtonerCtrl::PreCreateWindow(CREATESTRUCT& cs)
{
    cs.lpszClass = _T("BUTTON");
    return COleControl::PreCreateWindow(cs);
}


/////////////////////////////////////////////////////////////////////////////
// CButtonerCtrl::IsSubclassedControl -  

BOOL CButtonerCtrl::IsSubclassedControl()
{
    return TRUE;
}


/////////////////////////////////////////////////////////////////////////////
// CButtonerCtrl::OnOcmCommand -   

LRESULT CButtonerCtrl::OnOcmCommand(WPARAM wParam, LPARAM lParam)
{
#ifdef _WIN32
    WORD wNotifyCode = HIWORD(wParam);
#else
    WORD wNotifyCode = HIWORD(lParam);
#endif

    // TODO:   wNotifyCode.

    return 0;
}


/////////////////////////////////////////////////////////////////////////////
//   CButtonerCtrl


void CButtonerCtrl::OnLButtonDown(UINT nFlags, CPoint point) 
{
    // TODO:     
    // /    
    FireClick();

    m_data++;

    COleControl::OnLButtonDown(nFlags, point);
}

void CButtonerCtrl::OnDataChanged() 
{
    // TODO:       
    SetModifiedFlag();
}


void CButtonerCtrl::Beep() 
{
    // TODO:    
    MessageBeep(MB_OK);
}

