class CData : public CObject {
private:
    CString data;
    DECLARE_SERIAL(CData);
public:
    CData(){data = CString("");}
    void AddText(CString text){data += text;}
    void DrawText(CDC* pDC){pDC->TextOut(0, 0, data);}
    void ClearText(){data = "";}
    void Serialize(CArchive& archive);
};


#include "stdafx.h"
#include "serializerDoc.h"

void CData::Serialize(CArchive& archive)
{
    CObject::Serialize(archive);
    if(archive.IsStoring()){
        archive << data;
    }
    else{
        archive >> data;
    }
}


