// combosDlg.cpp :  
//

#include "stdafx.h"
#include "combos.h"
#include "combosDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
//   CAboutDlg,    About

class CAboutDlg : public CDialog
{
public:
    CAboutDlg();

//   
    //{{AFX_DATA(CAboutDlg)
    enum { IDD = IDD_ABOUTBOX };
    //}}AFX_DATA

    //   ,  ClassWizard
    //{{AFX_VIRTUAL(CAboutDlg)
    protected:
    virtual void DoDataExchange(CDataExchange* pDX);    //  DDX/DDV
    //}}AFX_VIRTUAL

// 
protected:
    //{{AFX_MSG(CAboutDlg)
    //}}AFX_MSG
    DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
    //{{AFX_DATA_INIT(CAboutDlg)
    //}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
    CDialog::DoDataExchange(pDX);
    //{{AFX_DATA_MAP(CAboutDlg)
    //}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
    //{{AFX_MSG_MAP(CAboutDlg)
        //   
    //}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
//   CCombosDlg

CCombosDlg::CCombosDlg(CWnd* pParent /*=NULL*/)
    : CDialog(CCombosDlg::IDD, pParent)
{
    //{{AFX_DATA_INIT(CCombosDlg)
    m_text = _T("");
    //}}AFX_DATA_INIT
    //    ,   Win32 LoadIcon 
    //     DestroyIcon
    m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CCombosDlg::DoDataExchange(CDataExchange* pDX)
{
    CDialog::DoDataExchange(pDX);
    //{{AFX_DATA_MAP(CCombosDlg)
    DDX_Control(pDX, IDC_COMBO1, m_combo);
    DDX_Text(pDX, IDC_EDIT1, m_text);
    //}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CCombosDlg, CDialog)
    //{{AFX_MSG_MAP(CCombosDlg)
    ON_WM_SYSCOMMAND()
    ON_WM_PAINT()
    ON_WM_QUERYDRAGICON()
    ON_CBN_SELCHANGE(IDC_COMBO1, OnSelchangeCombo1)
    //}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
//   CCombosDlg

BOOL CCombosDlg::OnInitDialog()
{
    CDialog::OnInitDialog();

    m_combo.AddString(" 01");
    m_combo.AddString(" 02");
    m_combo.AddString(" 03");
    m_combo.AddString(" 04");
    m_combo.AddString(" 05");
    m_combo.AddString(" 06");
    m_combo.AddString(" 07");
    m_combo.AddString(" 08");
    m_combo.AddString(" 09");
    m_combo.AddString(" 10");
    m_combo.AddString(" 11");
    m_combo.AddString(" 12");
    m_combo.SetCurSel(0);

    //   "About..."   .

    //  IDM_ABOUTBOX    
    //  .
    ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
    ASSERT(IDM_ABOUTBOX < 0xF000);

    CMenu* pSysMenu = GetSystemMenu(FALSE);
    if (pSysMenu != NULL)
    {
        CString strAboutMenu;
        strAboutMenu.LoadString(IDS_ABOUTBOX);
        if (!strAboutMenu.IsEmpty())
        {
            pSysMenu->AppendMenu(MF_SEPARATOR);
            pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
        }
    }

    //     .   
    // ,       .
    SetIcon(m_hIcon, TRUE);         //   
    SetIcon(m_hIcon, FALSE);        //   
    
    // TODO:   
    
    return TRUE;  //  TRUE,       
}

void CCombosDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
    if ((nID & 0xFFF0) == IDM_ABOUTBOX)
    {
        CAboutDlg dlgAbout;
        dlgAbout.DoModal();
    }
    else
    {
        CDialog::OnSysCommand(nID, lParam);
    }
}

//       , 
//      .   MFC,
//   /,   .

void CCombosDlg::OnPaint() 
{
    if (IsIconic())
    {
        CPaintDC dc(this); //    

        SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

        //      
        int cxIcon = GetSystemMetrics(SM_CXICON);
        int cyIcon = GetSystemMetrics(SM_CYICON);
        CRect rect;
        GetClientRect(&rect);
        int x = (rect.Width() - cxIcon + 1) / 2;
        int y = (rect.Height() - cyIcon + 1) / 2;

        //  
        dc.DrawIcon(x, y, m_hIcon);
    }
    else
    {
        CDialog::OnPaint();
    }
}

//     ,  
//   .

HCURSOR CCombosDlg::OnQueryDragIcon()
{
    return (HCURSOR) m_hIcon;
}

void CCombosDlg::OnSelchangeCombo1() 
{
    // TODO:       
    m_combo.GetLBText(m_combo.GetCurSel(), m_text);
    UpdateData(false);
    
}

