// editorView.cpp :   CEditorView
//

#include "stdafx.h"
#include "editor.h"

#include "editorDoc.h"
#include "editorView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CEditorView

IMPLEMENT_DYNCREATE(CEditorView, CEditView)

BEGIN_MESSAGE_MAP(CEditorView, CEditView)
    //{{AFX_MSG_MAP(CEditorView)
    ON_COMMAND(ID_EDIT_CLEAR, OnEditClear)
    ON_UPDATE_COMMAND_UI(ID_EDIT_CLEAR, OnUpdateEditClear)
    //}}AFX_MSG_MAP
    //   
    ON_COMMAND(ID_FILE_PRINT, CEditView::OnFilePrint)
    ON_COMMAND(ID_FILE_PRINT_DIRECT, CEditView::OnFilePrint)
    ON_COMMAND(ID_FILE_PRINT_PREVIEW, CEditView::OnFilePrintPreview)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// / CEditorView

CEditorView::CEditorView()
{
    // TODO:   

}

CEditorView::~CEditorView()
{
}

BOOL CEditorView::PreCreateWindow(CREATESTRUCT& cs)
{
    // TODO:      , 
    //  CREATESTRUCT cs

    BOOL bPreCreated = CEditView::PreCreateWindow(cs);
    cs.style &= ~(ES_AUTOHSCROLL|WS_HSCROLL);    //   

    return bPreCreated;
}

/////////////////////////////////////////////////////////////////////////////
//   CEditorView

void CEditorView::OnDraw(CDC* pDC)
{
    CEditorDoc* pDoc = GetDocument();
    ASSERT_VALID(pDoc);

    // TODO:     
}

/////////////////////////////////////////////////////////////////////////////
//   CEditorView

BOOL CEditorView::OnPreparePrinting(CPrintInfo* pInfo)
{
    //    CEditView 
    return CEditView::OnPreparePrinting(pInfo);
}

void CEditorView::OnBeginPrinting(CDC* pDC, CPrintInfo* pInfo)
{
    //      CEditView
    CEditView::OnBeginPrinting(pDC, pInfo);
}

void CEditorView::OnEndPrinting(CDC* pDC, CPrintInfo* pInfo)
{
    //      CEditView
    CEditView::OnEndPrinting(pDC, pInfo);
}

/////////////////////////////////////////////////////////////////////////////
//   CEditorView

#ifdef _DEBUG
void CEditorView::AssertValid() const
{
    CEditView::AssertValid();
}

void CEditorView::Dump(CDumpContext& dc) const
{
    CEditView::Dump(dc);
}

CEditorDoc* CEditorView::GetDocument() // - 
                                       //  
{
    ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CEditorDoc)));
    return (CEditorDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
//   CEditorView

void CEditorView::OnEditClear() 
{
    GetEditCtrl().Clear();
    
}

void CEditorView::OnUpdateEditClear(CCmdUI* pCmdUI) 
{
pCmdUI->Enable(true);    
}

