// sellerDlg.cpp :  
//

#include "stdafx.h"
#include "seller.h"
#include "sellerDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
//   CAboutDlg,    About

class CAboutDlg : public CDialog
{
public:
    CAboutDlg();

//   
    //{{AFX_DATA(CAboutDlg)
    enum { IDD = IDD_ABOUTBOX };
    //}}AFX_DATA

    //   ,  ClassWizard
    //{{AFX_VIRTUAL(CAboutDlg)
    protected:
    virtual void DoDataExchange(CDataExchange* pDX);    //  DDX/DDV
    //}}AFX_VIRTUAL

// 
protected:
    //{{AFX_MSG(CAboutDlg)
    //}}AFX_MSG
    DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
    //{{AFX_DATA_INIT(CAboutDlg)
    //}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
    CDialog::DoDataExchange(pDX);
    //{{AFX_DATA_MAP(CAboutDlg)
    //}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
    //{{AFX_MSG_MAP(CAboutDlg)
        //   
    //}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
//   CSellerDlg

CSellerDlg::CSellerDlg(CWnd* pParent /*=NULL*/)
    : CDialog(CSellerDlg::IDD, pParent)
{
    //{{AFX_DATA_INIT(CSellerDlg)
    m_check1 = FALSE;
    m_check2 = FALSE;
    m_check3 = FALSE;
    m_check4 = FALSE;
    m_text = _T("");
    //}}AFX_DATA_INIT
    //    ,   Win32 LoadIcon 
    //     DestroyIcon
    m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CSellerDlg::DoDataExchange(CDataExchange* pDX)
{
    CDialog::DoDataExchange(pDX);
    //{{AFX_DATA_MAP(CSellerDlg)
    DDX_Check(pDX, IDC_CHECK1, m_check1);
    DDX_Check(pDX, IDC_CHECK2, m_check2);
    DDX_Check(pDX, IDC_CHECK3, m_check3);
    DDX_Check(pDX, IDC_CHECK4, m_check4);
    DDX_Text(pDX, IDC_EDIT1, m_text);
    //}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CSellerDlg, CDialog)
    //{{AFX_MSG_MAP(CSellerDlg)
    ON_WM_SYSCOMMAND()
    ON_WM_PAINT()
    ON_WM_QUERYDRAGICON()
    ON_BN_CLICKED(IDC_RADIO1, OnRadio1)
    ON_BN_CLICKED(IDC_RADIO2, OnRadio2)
    ON_BN_CLICKED(IDC_RADIO3, OnRadio3)
    ON_BN_CLICKED(IDC_RADIO4, OnRadio4)
    //}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
//   CSellerDlg

BOOL CSellerDlg::OnInitDialog()
{
    CDialog::OnInitDialog();

    //   "About..."   .

    //  IDM_ABOUTBOX    
    //  .

    ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
    ASSERT(IDM_ABOUTBOX < 0xF000);

    CMenu* pSysMenu = GetSystemMenu(FALSE);
    if (pSysMenu != NULL)
    {
        CString strAboutMenu;
        strAboutMenu.LoadString(IDS_ABOUTBOX);
        if (!strAboutMenu.IsEmpty())
        {
            pSysMenu->AppendMenu(MF_SEPARATOR);
            pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
        }
    }

    //     .   
    // ,       .
    SetIcon(m_hIcon, TRUE);         //   
    SetIcon(m_hIcon, FALSE);        //   
    
    // TODO:   
    
    return TRUE;  //  TRUE,       
}

void CSellerDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
    if ((nID & 0xFFF0) == IDM_ABOUTBOX)
    {
        CAboutDlg dlgAbout;
        dlgAbout.DoModal();
    }
    else
    {
        CDialog::OnSysCommand(nID, lParam);
    }
}

//       , 
//      .   MFC,
//   /,   .

void CSellerDlg::OnPaint() 
{
    if (IsIconic())
    {
        CPaintDC dc(this); //    

        SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

        //      
        int cxIcon = GetSystemMetrics(SM_CXICON);
        int cyIcon = GetSystemMetrics(SM_CYICON);
        CRect rect;
        GetClientRect(&rect);
        int x = (rect.Width() - cxIcon + 1) / 2;
        int y = (rect.Height() - cyIcon + 1) / 2;

        //  
        dc.DrawIcon(x, y, m_hIcon);
    }
    else
    {
        CDialog::OnPaint();
    }
}

//     ,  
//   .
HCURSOR CSellerDlg::OnQueryDragIcon()
{
    return (HCURSOR) m_hIcon;
}

void CSellerDlg::OnRadio1() 
{
    // TODO:       
    m_check1 = true;
    m_check2 = true;
    m_check3 = true;
    m_check4 = true;
    m_text = ": $4.95";
    UpdateData(false);
}

void CSellerDlg::OnRadio2() 
{
    m_check1 = true;
    m_check2 = false;
    m_check3 = true;
    m_check4 = false;
    m_text = ": $3.95";
    UpdateData(false);
}

void CSellerDlg::OnRadio3() 
{
    m_check1 = false;
    m_check2 = true;
    m_check3 = false;
    m_check4 = true;
    m_text = ": $2.95";
    UpdateData(false);
}

void CSellerDlg::OnRadio4() 
{
    m_check1 = false;
    m_check2 = false;
    m_check3 = false;
    m_check4 = false;
    m_text = ": $0.00";
    UpdateData(false);
}

