// slidersDlg.cpp :  
//

#include "stdafx.h"
#include "sliders.h"
#include "slidersDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
//   CAboutDlg,    About

class CAboutDlg : public CDialog
{
public:
    CAboutDlg();

//   
    //{{AFX_DATA(CAboutDlg)
    enum { IDD = IDD_ABOUTBOX };
    //}}AFX_DATA

    //   ,  ClassWizard
    //{{AFX_VIRTUAL(CAboutDlg)
    protected:
    virtual void DoDataExchange(CDataExchange* pDX);    //  DDX/DDV
    //}}AFX_VIRTUAL

// 
protected:
    //{{AFX_MSG(CAboutDlg)
    //}}AFX_MSG
    DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
    //{{AFX_DATA_INIT(CAboutDlg)
    //}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
    CDialog::DoDataExchange(pDX);
    //{{AFX_DATA_MAP(CAboutDlg)
    //}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
    //{{AFX_MSG_MAP(CAboutDlg)
        //   
    //}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
//   CSlidersDlg

CSlidersDlg::CSlidersDlg(CWnd* pParent /*=NULL*/)
    : CDialog(CSlidersDlg::IDD, pParent)
{
    //{{AFX_DATA_INIT(CSlidersDlg)
    m_text = _T("");
    //}}AFX_DATA_INIT
    //    ,   Win32 LoadIcon 
    //     DestroyIcon
    m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CSlidersDlg::DoDataExchange(CDataExchange* pDX)
{
    CDialog::DoDataExchange(pDX);
    //{{AFX_DATA_MAP(CSlidersDlg)
    DDX_Control(pDX, IDC_EDIT1, m_textbox);
    DDX_Control(pDX, IDC_SLIDER1, m_slider);
    DDX_Text(pDX, IDC_EDIT1, m_text);
    //}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CSlidersDlg, CDialog)
    //{{AFX_MSG_MAP(CSlidersDlg)
    ON_WM_SYSCOMMAND()
    ON_WM_PAINT()
    ON_WM_QUERYDRAGICON()
    ON_WM_HSCROLL()
    //}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
//   CSlidersDlg

BOOL CSlidersDlg::OnInitDialog()
{
    CDialog::OnInitDialog();

    m_slider.SetRangeMin(1, false);
    m_slider.SetRangeMax(100, false);
    m_text = "1";
    UpdateData(false);

    //   "About..."   .

    //  IDM_ABOUTBOX    
    //  .
    ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
    ASSERT(IDM_ABOUTBOX < 0xF000);

    CMenu* pSysMenu = GetSystemMenu(FALSE);
    if (pSysMenu != NULL)
    {
        CString strAboutMenu;
        strAboutMenu.LoadString(IDS_ABOUTBOX);
        if (!strAboutMenu.IsEmpty())
        {
            pSysMenu->AppendMenu(MF_SEPARATOR);
            pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
        }
    }

    //     .   
    // ,       .
    SetIcon(m_hIcon, TRUE);         //   
    SetIcon(m_hIcon, FALSE);        //   
    
    // TODO:   
    
    return TRUE;  //  TRUE,       
}

void CSlidersDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
    if ((nID & 0xFFF0) == IDM_ABOUTBOX)
    {
        CAboutDlg dlgAbout;
        dlgAbout.DoModal();
    }
    else
    {
        CDialog::OnSysCommand(nID, lParam);
    }
}

//       , 
//      .   MFC,
//   /,   .

void CSlidersDlg::OnPaint() 
{
    if (IsIconic())
    {
        CPaintDC dc(this); //    

        SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

        //      
        int cxIcon = GetSystemMetrics(SM_CXICON);
        int cyIcon = GetSystemMetrics(SM_CYICON);
        CRect rect;
        GetClientRect(&rect);
        int x = (rect.Width() - cxIcon + 1) / 2;
        int y = (rect.Height() - cyIcon + 1) / 2;

        //  
        dc.DrawIcon(x, y, m_hIcon);
    }
    else
    {
        CDialog::OnPaint();
    }
}

//     ,  
//   .
HCURSOR CSlidersDlg::OnQueryDragIcon()
{
    return (HCURSOR) m_hIcon;
}

void CSlidersDlg::OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{
    // TODO:     
    // /    
    if(nSBCode == SB_THUMBPOSITION){
        m_text.Format("%ld", nPos);
        UpdateData(false);
    }
    else{
        CDialog::OnHScroll(nSBCode, nPos, pScrollBar);
    }
}

