// browserDlg.cpp :  
//

#include "stdafx.h"
#include "browser.h"
#include "browserDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
//   CAboutDlg,    About

class CAboutDlg : public CDialog
{
public:
    CAboutDlg();

//   
    //{{AFX_DATA(CAboutDlg)
    enum { IDD = IDD_ABOUTBOX };
    //}}AFX_DATA

    //   ,  ClassWizard
    //{{AFX_VIRTUAL(CAboutDlg)
    protected:
    virtual void DoDataExchange(CDataExchange* pDX);    //  DDX/DDV
    //}}AFX_VIRTUAL

// 
protected:
    //{{AFX_MSG(CAboutDlg)
    //}}AFX_MSG
    DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
    //{{AFX_DATA_INIT(CAboutDlg)
    //}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
    CDialog::DoDataExchange(pDX);
    //{{AFX_DATA_MAP(CAboutDlg)
    //}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
    //{{AFX_MSG_MAP(CAboutDlg)
        //   
    //}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
//   CBrowserDlg

CBrowserDlg::CBrowserDlg(CWnd* pParent /*=NULL*/)
    : CDialog(CBrowserDlg::IDD, pParent)
{
    //{{AFX_DATA_INIT(CBrowserDlg)
        // :  ClassWizard    
    //}}AFX_DATA_INIT
    //    ,   Win32 LoadIcon 
    //     DestroyIcon
    m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CBrowserDlg::DoDataExchange(CDataExchange* pDX)
{
    CDialog::DoDataExchange(pDX);
    //{{AFX_DATA_MAP(CBrowserDlg)
    DDX_Control(pDX, IDC_EXPLORER1, m_browser);
    //}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CBrowserDlg, CDialog)
    //{{AFX_MSG_MAP(CBrowserDlg)
    ON_WM_SYSCOMMAND()
    ON_WM_PAINT()
    ON_WM_QUERYDRAGICON()
    ON_BN_CLICKED(IDC_BUTTON1, OnButton1)
    //}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
//   CBrowserDlg

BOOL CBrowserDlg::OnInitDialog()
{
    CDialog::OnInitDialog();

    //   "About..."   .

    //  IDM_ABOUTBOX    
    //  .
    ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
    ASSERT(IDM_ABOUTBOX < 0xF000);

    CMenu* pSysMenu = GetSystemMenu(FALSE);
    if (pSysMenu != NULL)
    {
        CString strAboutMenu;
        strAboutMenu.LoadString(IDS_ABOUTBOX);
        if (!strAboutMenu.IsEmpty())
        {
            pSysMenu->AppendMenu(MF_SEPARATOR);
            pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
        }
    }

    //     .   
    // ,       .
    SetIcon(m_hIcon, TRUE);         //   
    SetIcon(m_hIcon, FALSE);        //   
    
    // TODO:   
    
    return TRUE;  //  TRUE,       
}

void CBrowserDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
    if ((nID & 0xFFF0) == IDM_ABOUTBOX)
    {
        CAboutDlg dlgAbout;
        dlgAbout.DoModal();
    }
    else
    {
        CDialog::OnSysCommand(nID, lParam);
    }
}

//       , 
//      .   MFC,
//   /,   .

void CBrowserDlg::OnPaint() 
{
    if (IsIconic())
    {
        CPaintDC dc(this); //    

        SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

        //      
        int cxIcon = GetSystemMetrics(SM_CXICON);
        int cyIcon = GetSystemMetrics(SM_CYICON);
        CRect rect;
        GetClientRect(&rect);
        int x = (rect.Width() - cxIcon + 1) / 2;
        int y = (rect.Height() - cyIcon + 1) / 2;

        //  
        dc.DrawIcon(x, y, m_hIcon);
    }
    else
    {
        CDialog::OnPaint();
    }
}

//     ,  
//   .

HCURSOR CBrowserDlg::OnQueryDragIcon()
{
    return (HCURSOR) m_hIcon;
}

void CBrowserDlg::OnButton1() 
{
    // TODO:       
    m_browser.Navigate("http://www.microsoft.com", 0, 0, 0, 0);
}
