// filerDlg.cpp :  
//

#include "stdafx.h"
#include "filer.h"
#include "filerDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
//   CAboutDlg,    About

class CAboutDlg : public CDialog
{
public:
    CAboutDlg();

//   
    //{{AFX_DATA(CAboutDlg)
    enum { IDD = IDD_ABOUTBOX };
    //}}AFX_DATA

    //   ,  ClassWizard
    //{{AFX_VIRTUAL(CAboutDlg)
    protected:
    virtual void DoDataExchange(CDataExchange* pDX);    //  DDX/DDV
    //}}AFX_VIRTUAL

// 
protected:
    //{{AFX_MSG(CAboutDlg)
    //}}AFX_MSG
    DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
    //{{AFX_DATA_INIT(CAboutDlg)
    //}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
    CDialog::DoDataExchange(pDX);
    //{{AFX_DATA_MAP(CAboutDlg)
    //}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
    //{{AFX_MSG_MAP(CAboutDlg)
        // No message handlers
    //}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
//   CFilerDlg

CFilerDlg::CFilerDlg(CWnd* pParent /*=NULL*/)
    : CDialog(CFilerDlg::IDD, pParent)
{
    //{{AFX_DATA_INIT(CFilerDlg)
    m_text1 = _T("");
    m_text2 = _T("");
    //}}AFX_DATA_INIT
    //    ,   Win32 LoadIcon 
    //     DestroyIcon
    m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CFilerDlg::DoDataExchange(CDataExchange* pDX)
{
    CDialog::DoDataExchange(pDX);
    //{{AFX_DATA_MAP(CFilerDlg)
    DDX_Text(pDX, IDC_EDIT1, m_text1);
    DDX_Text(pDX, IDC_EDIT2, m_text2);
    //}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CFilerDlg, CDialog)
    //{{AFX_MSG_MAP(CFilerDlg)
    ON_WM_SYSCOMMAND()
    ON_WM_PAINT()
    ON_WM_QUERYDRAGICON()
    ON_BN_CLICKED(IDC_BUTTON1, OnButton1)
    //}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
//   CFilerDlg

BOOL CFilerDlg::OnInitDialog()
{
    CDialog::OnInitDialog();

    strcpy(OutString[0], " ");
    strcpy(OutString[1], " ");
    strcpy(OutString[2], " ");
    strcpy(OutString[3], " ");

    m_text1 = CString(OutString[0]) + CString(OutString[1]) + 
              CString(OutString[2]) + CString(OutString[3]);
    UpdateData(false);

    //   "About..."   .

    //  IDM_ABOUTBOX    
    //  .
    ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
    ASSERT(IDM_ABOUTBOX < 0xF000);

    CMenu* pSysMenu = GetSystemMenu(FALSE);
    if (pSysMenu != NULL)
    {
        CString strAboutMenu;
        strAboutMenu.LoadString(IDS_ABOUTBOX);
        if (!strAboutMenu.IsEmpty())
        {
            pSysMenu->AppendMenu(MF_SEPARATOR);
            pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
        }
    }

    //     .   
    // ,       .
    SetIcon(m_hIcon, TRUE);         //   
    SetIcon(m_hIcon, FALSE);        //   
    
    // TODO:   
    
    return TRUE;  //  TRUE,       
}

void CFilerDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
    if ((nID & 0xFFF0) == IDM_ABOUTBOX)
    {
        CAboutDlg dlgAbout;
        dlgAbout.DoModal();
    }
    else
    {
        CDialog::OnSysCommand(nID, lParam);
    }
}

//       , 
//      .   MFC,
//   /,   .

void CFilerDlg::OnPaint() 
{
    if (IsIconic())
    {
        CPaintDC dc(this); //    

        SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

        //      
        int cxIcon = GetSystemMetrics(SM_CXICON);
        int cyIcon = GetSystemMetrics(SM_CYICON);
        CRect rect;
        GetClientRect(&rect);
        int x = (rect.Width() - cxIcon + 1) / 2;
        int y = (rect.Height() - cyIcon + 1) / 2;

        //  
        dc.DrawIcon(x, y, m_hIcon);
    }
    else
    {
        CDialog::OnPaint();
    }
}

//     ,  
//   .

HCURSOR CFilerDlg::OnQueryDragIcon()
{
    return (HCURSOR) m_hIcon;
}

void CFilerDlg::OnButton1() 
{
    CFile OutFile("data.dat", CFile::modeCreate | CFile::modeWrite);
    for(int loop_index = 0; loop_index < 4; loop_index++){
        OutFile.Write(OutString[loop_index], 20);
    }
    OutFile.Close();

    CFile InFile("data.dat", CFile::modeRead);
    for(loop_index = 0; loop_index < 4; loop_index++){
        InFile.Seek(20 * loop_index, CFile::begin);
        int NumberCharacters = InFile.Read(InString, 20);
        m_text2 += CString(InString);
    }
    UpdateData(false);
    InFile.Close();
}

