// keystrokesView.cpp :   CKeystrokesView
//

#include "stdafx.h"
#include "keystrokes.h"

#include "keystrokesDoc.h"
#include "keystrokesView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CKeystrokesView

IMPLEMENT_DYNCREATE(CKeystrokesView, CView)

BEGIN_MESSAGE_MAP(CKeystrokesView, CView)
    //{{AFX_MSG_MAP(CKeystrokesView)
    ON_WM_CHAR()
    //}}AFX_MSG_MAP
    //   
    ON_COMMAND(ID_FILE_PRINT, CView::OnFilePrint)
    ON_COMMAND(ID_FILE_PRINT_DIRECT, CView::OnFilePrint)
    ON_COMMAND(ID_FILE_PRINT_PREVIEW, CView::OnFilePrintPreview)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// / CKeystrokesView

CKeystrokesView::CKeystrokesView()
{
    // TODO:   

}

CKeystrokesView::~CKeystrokesView()
{
}

BOOL CKeystrokesView::PreCreateWindow(CREATESTRUCT& cs)
{
    // TODO:      , 
    //  CREATESTRUCT cs

    return CView::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
//   CKeystrokesView

void CKeystrokesView::OnDraw(CDC* pDC)
{
    CKeystrokesDoc* pDoc = GetDocument();
    ASSERT_VALID(pDoc);

    pDC->TextOut(0, 0, pDoc->StringData);
    // TODO:     
}

/////////////////////////////////////////////////////////////////////////////
//   CKeystrokesView

BOOL CKeystrokesView::OnPreparePrinting(CPrintInfo* pInfo)
{
    //  
    return DoPreparePrinting(pInfo);
}

void CKeystrokesView::OnBeginPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
    // TODO:     
}

void CKeystrokesView::OnEndPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
    // TODO:    " "  
}

/////////////////////////////////////////////////////////////////////////////
//   CKeystrokesView

#ifdef _DEBUG
void CKeystrokesView::AssertValid() const
{
    CView::AssertValid();
}

void CKeystrokesView::Dump(CDumpContext& dc) const
{
    CView::Dump(dc);
}

CKeystrokesDoc* CKeystrokesView::GetDocument() // - 
                                               //  
{
    ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CKeystrokesDoc)));
    return (CKeystrokesDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
//   CKeystrokesView

void CKeystrokesView::OnChar(UINT nChar, UINT nRepCnt, UINT nFlags) 
{
    // TODO:     
    // /    
    
    CKeystrokesDoc* pDoc = GetDocument();
    ASSERT_VALID(pDoc);
    pDoc->StringData += nChar;
    Invalidate();

    CView::OnChar(nChar, nRepCnt, nFlags);
}

