// scrollerView.cpp :   CScrollerView
//

#include "stdafx.h"
#include "scroller.h"

#include "scrollerDoc.h"
#include "scrollerView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CScrollerView

IMPLEMENT_DYNCREATE(CScrollerView, CScrollView)

BEGIN_MESSAGE_MAP(CScrollerView, CScrollView)
    //{{AFX_MSG_MAP(CScrollerView)
    ON_WM_CHAR()
    //}}AFX_MSG_MAP
    //   
    ON_COMMAND(ID_FILE_PRINT, CScrollView::OnFilePrint)
    ON_COMMAND(ID_FILE_PRINT_DIRECT, CScrollView::OnFilePrint)
    ON_COMMAND(ID_FILE_PRINT_PREVIEW, CScrollView::OnFilePrintPreview)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// / CScrollerView

CScrollerView::CScrollerView()
{
    // TODO:   

}

CScrollerView::~CScrollerView()
{
}

BOOL CScrollerView::PreCreateWindow(CREATESTRUCT& cs)
{
    // TODO:      , 
    //  CREATESTRUCT cs

    return CScrollView::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
//   CScrollerView

void CScrollerView::OnDraw(CDC* pDC)
{
    CScrollerDoc* pDoc = GetDocument();
    ASSERT_VALID(pDoc);

    pDC->TextOut(0, 0, pDoc->StringData);
    // TODO:     
}

void CScrollerView::OnInitialUpdate()
{
    CScrollView::OnInitialUpdate();
    CSize sizeTotal;
    // TODO:    
    //sizeTotal.cx = sizeTotal.cy = 100;
    CScrollerDoc* pDoc = GetDocument();
    ASSERT_VALID(pDoc);

    sizeTotal.cx = pDoc->GetDocSize().cx;
    sizeTotal.cy = pDoc->GetDocSize().cy;
    SetScrollSizes(MM_TEXT, sizeTotal);
}

/////////////////////////////////////////////////////////////////////////////
//   CScrollerView

BOOL CScrollerView::OnPreparePrinting(CPrintInfo* pInfo)
{
    //  
    return DoPreparePrinting(pInfo);
}

void CScrollerView::OnBeginPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
    // TODO:     
}

void CScrollerView::OnEndPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
    // TODO:    " "  
}

/////////////////////////////////////////////////////////////////////////////
//   CScrollerView

#ifdef _DEBUG
void CScrollerView::AssertValid() const
{
    CScrollView::AssertValid();
}

void CScrollerView::Dump(CDumpContext& dc) const
{
    CScrollView::Dump(dc);
}

CScrollerDoc* CScrollerView::GetDocument() // - 
                                           //  
{
    ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CScrollerDoc)));
    return (CScrollerDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
//   CScrollerView

void CScrollerView::OnChar(UINT nChar, UINT nRepCnt, UINT nFlags) 
{
    // TODO:    
    // /    
    CScrollerDoc* pDoc = GetDocument();
    ASSERT_VALID(pDoc);

    pDoc->StringData += nChar;
    Invalidate(); 

    pDoc->UpdateAllViews(this, 0L, NULL);
    pDoc->SetModifiedFlag();

    CScrollView::OnChar(nChar, nRepCnt, nFlags);
}

