// serializerView.cpp :   CSerializerView
//

#include "stdafx.h"
#include "serializer.h"

#include "serializerDoc.h"
#include "serializerView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CSerializerView

IMPLEMENT_DYNCREATE(CSerializerView, CView)

BEGIN_MESSAGE_MAP(CSerializerView, CView)
    //{{AFX_MSG_MAP(CSerializerView)
    ON_WM_CHAR()
    //}}AFX_MSG_MAP
    //   
    ON_COMMAND(ID_FILE_PRINT, CView::OnFilePrint)
    ON_COMMAND(ID_FILE_PRINT_DIRECT, CView::OnFilePrint)
    ON_COMMAND(ID_FILE_PRINT_PREVIEW, CView::OnFilePrintPreview)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// / CSerializerView

CSerializerView::CSerializerView()
{
    // TODO:   

}

CSerializerView::~CSerializerView()
{
}

BOOL CSerializerView::PreCreateWindow(CREATESTRUCT& cs)
{
    // TODO:      , 
    //  CREATESTRUCT cs

    return CView::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
//   CSerializerView

void CSerializerView::OnDraw(CDC* pDC)
{
    CSerializerDoc* pDoc = GetDocument();
    ASSERT_VALID(pDoc);

    pDoc->DataObject.DrawText(pDC);
    // TODO:     
}

/////////////////////////////////////////////////////////////////////////////
//   CSerializerView

BOOL CSerializerView::OnPreparePrinting(CPrintInfo* pInfo)
{
    //  
    return DoPreparePrinting(pInfo);
}

void CSerializerView::OnBeginPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
    // TODO:     
}

void CSerializerView::OnEndPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
    // TODO:    " "  
}

/////////////////////////////////////////////////////////////////////////////
//   CSerializerView

#ifdef _DEBUG
void CSerializerView::AssertValid() const
{
    CView::AssertValid();
}

void CSerializerView::Dump(CDumpContext& dc) const
{
    CView::Dump(dc);
}

CSerializerDoc* CSerializerView::GetDocument() // - 
                                               //  
{
    ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CSerializerDoc)));
    return (CSerializerDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
//   CSerializerView

void CSerializerView::OnChar(UINT nChar, UINT nRepCnt, UINT nFlags) 
{
    // TODO:    
    // /    
    CSerializerDoc* pDoc = GetDocument();
    ASSERT_VALID(pDoc);

    pDoc->DataObject.AddText(CString(nChar));
    Invalidate();
    CView::OnChar(nChar, nRepCnt, nFlags);
}

