// writerView.cpp :   CWriterView
//

#include "stdafx.h"
#include "writer.h"

#include "writerDoc.h"
#include "writerView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CWriterView

IMPLEMENT_DYNCREATE(CWriterView, CView)

BEGIN_MESSAGE_MAP(CWriterView, CView)
    //{{AFX_MSG_MAP(CWriterView)
    ON_WM_CHAR()
    //}}AFX_MSG_MAP
    //   
    ON_COMMAND(ID_FILE_PRINT, CView::OnFilePrint)
    ON_COMMAND(ID_FILE_PRINT_DIRECT, CView::OnFilePrint)
    ON_COMMAND(ID_FILE_PRINT_PREVIEW, CView::OnFilePrintPreview)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// / CWriterView

CWriterView::CWriterView()
{
    // TODO:   

}

CWriterView::~CWriterView()
{
}

BOOL CWriterView::PreCreateWindow(CREATESTRUCT& cs)
{
    // TODO:      , 
    //  CREATESTRUCT cs

    return CView::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
//   CWriterView

void CWriterView::OnDraw(CDC* pDC)
{
    CWriterDoc* pDoc = GetDocument();
    ASSERT_VALID(pDoc);

    pDC->TextOut(0, 0, pDoc->StringData);

    // TODO:     
}

/////////////////////////////////////////////////////////////////////////////
//   CWriterView

BOOL CWriterView::OnPreparePrinting(CPrintInfo* pInfo)
{
    //  
    return DoPreparePrinting(pInfo);
}

void CWriterView::OnBeginPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
    // TODO:     
}

void CWriterView::OnEndPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
    // TODO:    " "  
}

/////////////////////////////////////////////////////////////////////////////
//   CWriterView

#ifdef _DEBUG
void CWriterView::AssertValid() const
{
    CView::AssertValid();
}

void CWriterView::Dump(CDumpContext& dc) const
{
    CView::Dump(dc);
}

CWriterDoc* CWriterView::GetDocument() // - 
                                       //  
{
    ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CWriterDoc)));
    return (CWriterDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
//   CWriterView

void CWriterView::OnChar(UINT nChar, UINT nRepCnt, UINT nFlags) 
{
    // TODO:    
    // /    
    CWriterDoc* pDoc = GetDocument();
    ASSERT_VALID(pDoc);

    pDoc->StringData += nChar;
    Invalidate();
    pDoc->SetModifiedFlag();

    CView::OnChar(nChar, nRepCnt, nFlags);
}

